class AnnouncementsController < ApplicationController
  ViewRootDir = File.expand_path("../../views", __FILE__)
  include AnnouncementsHelper
  DefaultImgSrc = "/assets/announcement-default.jpg\" onerror=\"this.src=&quot;/assets/announcement-default-2.jpg&quot;;this.onerror='';"
  def initialize
    super
    @app_title = 'announcement'
    @manually_sort = manually_sort
    Bulletin.instance_variable_set('@manually_sort',@manually_sort)
    #self.request = OrbitHelper.request
  end
  def annc_depts_translations
    if defined?(OrbitHelper::SharedHash) && OrbitHelper::SharedHash
      OrbitHelper::SharedHash['announcement'][:annc_depts_translations] rescue AnnouncementSetting.first.annc_depts_translations
    else
      AnnouncementSetting.first.annc_depts_translations rescue {}
    end
  end
  def enable_annc_dept
    if defined?(OrbitHelper::SharedHash) && OrbitHelper::SharedHash
      OrbitHelper::SharedHash['announcement'][:enable_annc_dept] rescue AnnouncementSetting.first.enable_annc_dept
    else
      AnnouncementSetting.first.enable_annc_dept rescue false
    end
  end
  def manually_sort
    if defined?(OrbitHelper::SharedHash) && OrbitHelper::SharedHash
      OrbitHelper::SharedHash['announcement'][:enable_manually_sort] rescue AnnouncementSetting.first.enable_manually_sort
    else
      AnnouncementSetting.first.enable_manually_sort rescue false
    end
  end
  def render_400
    render(:file => "#{ViewRootDir}/announcements/400.html", :layout => false, :status => 400, :formats => [:html])
  end
  def render_404
    render(:file => "#{Rails.root}/app/views/errors/404.html", :layout => false, :status => 404, :formats => [:html])
  end
  def comment
    @bulletin = Bulletin.where(:uid=>params[:uid]).first
    comment_val = params['comment']
    if !@bulletin.nil? && @bulletin.open_comment_for_user(OrbitHelper.current_user) && !comment_val.blank?
      account_id = OrbitHelper.current_user.member_profile.id.to_s rescue 'visitor'
      b = BulletinComment.new(ip: request.remote_ip,comment: comment_val,account_id: account_id)
      b.bulletin_id = @bulletin.id
      b.save
      render :json => {}
    else
      render_404
    end
  end
  def index
    @type = 'index'
    Bulletin.remove_expired_status
    params = @params = OrbitHelper.params
    page = @page || Page.where(url: params['url']).first
    @enable_search_flag = false
    @image_version = 'thumb'
    if page.respond_to?(:select_option_items)
      ModuleApp.all.select{|tmp| tmp.key.to_s=='announcement'}.each do |modile_app|
        @show_option_items = modile_app.show_option_items rescue nil
      end
      I18n.with_locale(:en) do
        page.select_option_items.each do |select_option_item|
          if !(@show_option_items.nil?)
            case select_option_item.field_name
            when @show_option_items.keys[1].to_s
              value = YAML.load(select_option_item.value)
              if value[:en] == t('announcement.yes')
                @enable_search_flag = true
              end
            when @show_option_items.keys[2].to_s
              value = YAML.load(select_option_item.value)
              tmp = value[:en]
              if tmp == t('announcement.small_size')
                @image_version = 'thumb'
              elsif tmp == t('announcement.medium_size')
                @image_version = 'mobile'
              elsif tmp == t('announcement.orignal_size')
                @image_version = 'orignal'
              end
            end
          end
        end
      end
    end

    sorted,total_pages = get_sorted_annc
    if sorted.nil?
      sorted = []
      total_pages = 0
    end
    annc_depts = []
    tmp_enable_annc_dept = (enable_annc_dept rescue false)
    if tmp_enable_annc_dept
      annc_depts = annc_depts_translations[locale] rescue []
    end
    anns = sorted.collect do |a|
      if a["source-site"].blank?
        statuses = a.statuses_with_classname.collect do |status|
          {
            "status" => status["name"],
            "status-class" => "status-#{status['classname']}"
          }
        end
        locale = OrbitHelper.get_site_locale.to_s
        files = a.bulletin_files.to_fronted(locale)
        links = a.bulletin_links.map{|link|  { "link_url" => link.url, "link_title" => (link.title.blank? ? link.url : link.title) } } rescue []
        author = tmp_enable_annc_dept ? annc_depts[a.annc_dept] : User.find(a.update_user_id).member_name rescue (User.find(a.update_user_id).member_profile.name rescue "")
        desc = a.image_description
        desc = (desc.blank? ? "announcement image" : desc)
        link_to_show = a.is_external_link ? a.external_link :  OrbitHelper.url_to_show(a.to_param)
        target = a.is_external_link ? "_blank" : "_self"
        doc = Nokogiri::HTML(a.title)
        title = doc.text.empty? ? 'no content' : doc.text
        if @image_version == 'thumb'
          image_url = a.image.thumb.url
        elsif @image_version == 'mobile'
          image_url = a.image.mobile.url
        else
          image_url = a.image.url
        end
        {
          "department" => author,
          "bulletin_links" => links,
          "bulletin_files" => files,
          "title" => a.title,
          "source-site" => "",
          "source-site-title" => "",
          "source-site-link" => "",
          "subtitle" => a.subtitle,
          "statuses" => statuses,
          "category" => (a.category.title rescue ""),
          "postdate" => a.postdate,
          "author" => author,
          "is_top" => (a.is_top? ? 1 : 0),
          "link_to_show" => link_to_show+"\" #{(link_to_show[0] == '/' rescue true) ? '' : 'target="_blank"'} title=\"#{title}",
          "target" => target,
          "img_src" => image_url || DefaultImgSrc,
          "img_description" => desc,
          "more" => t("announcement.more"),
          "view_count" => a.view_count
        }
      else
        a
      end
    end
    if anns.count == 0 && params.any?{|k,v| v.class==Array ? v.any?{|v1| v1.to_s.match(/\*|\(|\)/)} : v.to_s.match(/\*|\(|\)/)}
      return nil
    end
    #If no data , hide title&table
    if sorted.count == 0
      display = "hide"
    end
    # anns = anns.concat(feeds_anns)
    # total_pages = announcements.total_pages
    page = Page.where(url:params['url']).first
    @annc_page_title = nil
    if (params['category'] != page.categories rescue true)
      @annc_page_title = Category.find(Array(params['category']).first).title rescue nil
    end
    if (params["tags"] != page.tags && !params["tags"].blank? && params["tags"].count == 1 && params["tags"][0] != "all" rescue true)
      @annc_page_title = Tag.find(Array(params['tags']).first).name rescue nil
    end
    {
      "announcements" => anns,
      "extras" => {
        "widget-title" =>t('announcement.announcement'),
        "title-head" => t('announcement.table.title'),
        "date-head" => t('announcement.table.date'),
        "status-head" => t('announcement.table.status'),
        "author-head" => t('announcement.table.author'),
        "subtitle-head" => t('announcement.table.sub_title'),
        "category-head" => t('announcement.table.category'),
        "link-head" => t('announcement.table.link'),
        "file-head" => t('announcement.table.file'),
        "view-count-head" => t('announcement.table.view_count'),
        "display" => display,
        "department-head" => t('announcement.table.department'),
        "annc-dept-head" => t("announcement.annc_dept"),
        "page-title" => @annc_page_title
      },
      "total_pages" => total_pages
    }

  end

  def random_announcement_widget
    pack_data(true)
  end

  def widget
    pack_data()
  end

  def tag_cloud
    ma = ModuleApp.where(:key => "announcement").first
    temp = []
    ma.tags.each do |tag|
      t1 = tag.taggings.collect{|t| t.taggable_id.to_s}
      count = Bulletin.where(:id.in => t1).can_display_and_sorted.count
      temp << {
        "tag-name" => tag.name,
        "count" => count,
        "tag-url" => OrbitHelper.widget_more_url + "?tags[]=" + tag.id.to_s
      }
    end
    max = temp.max_by{|t| t["count"]}["count"]
    tags = []
    temp.each do |tag|
      if tag["count"] > 0
        percent = (tag["count"] * 100) / max
        font_size = ((percent / 10).round) + 16
        tag["font-size"] = font_size
        tags << tag
      end
    end
    {
      "tags" => tags,
      "extras" => {}
    }
  end

  def pack_data(is_random=false)
    cats = OrbitHelper.widget_categories || []
    tags = OrbitHelper.widget_tags || []
    tags = ['all'] if tags.blank?
    subpart = OrbitHelper.get_current_widget
    get_tabs_option
    anns = []
    use_tag = false
    @annc_depts = []
    @tmp_enable_annc_dept = (enable_annc_dept rescue false)
    if @tmp_enable_annc_dept
      @annc_depts = annc_depts_translations[locale] rescue []
    end
    if @tab_option == 0
      anns = get_anncs_for_pack_data(cats,tags,nil,is_random)
    else
      if cats.count != 1 || tags == ["all"]
        cats.each do |cat|
          anns = anns + get_anncs_for_pack_data([cat],tags,'',is_random)
        end
      else
        tags.each do |tag|
          anns = anns + get_anncs_for_pack_data(cats,[tag],tag,is_random)
        end
        use_tag = true
      end
    end
    mp = (anns[0]["img_src"] rescue "")
    mpd = (anns[0]["img_description"] rescue "")
    if @tab_option == 1
      if use_tag
        tags = ["all"] + tags
      else
        cats = ["all"] + cats
      end
      if @manually_sort
        anns = anns.sort_by { |a| [ (a["is_top"] ? 1 : 0) , -a['sort_number'].to_i, a["postdate"].blank? ? nil : a["postdate"].to_time] }.reverse
      else
        anns = anns.sort_by { |a| [ (a["is_top"] ? 1 : 0) , a["postdate"].blank? ? nil : a["postdate"].to_time] }.reverse
      end
    end
    cats = cats.uniq
    tags = tags.uniq
    tags_translations = (subpart.get_tags_translations(false,false) rescue nil)
    tags_translations = Tag.where(:id.in=>tags).map{|t| [t.id.to_s,t.name]} if tags_translations.nil?
    if tags.include?("all")
      tags_translations = [["all",I18n.t(:all)]] + tags_translations
    end
    tags_translations = tags_translations.to_h
    cats_translations = (subpart.get_cats_translations(false,false) rescue nil)
    cats_translations = Category.where(:id.in=>cats).map{|c| [c.id.to_s,c.title]} if cats_translations.nil?
    if cats.include?("all")
      cats_translations = [["all",I18n.t(:all)]] + cats_translations
    end
    cats_translations = cats_translations.to_h
    if cats.include?("all")
      cats_relations = cats_translations.clone
      cats_relations['all'] = 'all'
    else
      cats_relations = cats_translations
    end
    page_url = (subpart.get_read_more_page_url rescue nil)
    locale = I18n.locale.to_s
    if page_url.nil?
      home_page = subpart.page_part.page rescue Page.first
      page = nil
      if home_page.respond_to?(:find_page)
        page = home_page.find_page(:page_id=> subpart.read_more_page_id,:enabled_for=>locale).first rescue nil
        page = home_page.find_page(:module=>"announcement",:enabled_for=>locale).first rescue nil if page.nil?
      else
        page = Page.where(:page_id=> subpart.read_more_page_id,:enabled_for=>locale).first rescue nil
        page = Page.where(:module=>"announcement",:enabled_for=>locale).first rescue nil if page.nil?
      end
      page_url = "/#{locale}#{(page.get_url rescue page.url)}"
    end
    all_cats = cats.dup
    all_cats.delete "all"
    if all_cats.count == 0
      all_cats = ["all"]
    end
    all_tags = tags.dup
    all_tags.delete "all"
    if all_tags.count == 0
      all_tags = ["all"]
    end
    max_all_count = [OrbitHelper.widget_data_count,anns.count].min
    if @tab_option != 0
      OrbitHelper.set_widget_title(OrbitHelper.widget_title + 
        "<div style=\"clear: both;\"></div>" +
        "<ul class=\"nav_tabs_filter\">" +
          (use_tag ? tags.map.with_index{|tag,i|
            read_more_url = "#{page_url}" rescue ""
            read_more_url = read_more_url + "?" + {"category"=>all_cats,"tags"=>(tag == 'all' ? all_tags : [tag])}.to_param if read_more_url != ""
            read_more_text = I18n.t("announcement.more")
            if tag != "all"
              begin
                read_more_text = I18n.t("announcement.more_") + tags_translations[tag]
              rescue 
                nil
              end
            end
            "<li class=\"filter_tab#{i == 0 ? ' active' : ''}\" #{(tag == 'all' && @all_setting_option == 0) ? "data-count_limit=\"#{max_all_count}\"" : ''} data-read_more_text=\"#{read_more_text}\" data-read_more=\"#{read_more_url}\" data-tags=\"#{tag}\">#{tags_translations[tag]}</li>"
          }.join("") : cats.map.with_index{|cat,i|
            read_more_url = "#{page_url}" rescue ""
            read_more_url = read_more_url + "?" + {"category"=>(cat == 'all' ? all_cats : cat)}.to_param if read_more_url != ""
            read_more_text = I18n.t("announcement.more")
            if cat != "all"
              begin
                read_more_text = I18n.t("announcement.more_") + cats_translations[cat]
              rescue 
                nil
              end
            end
            "<li class=\"filter_tab#{i == 0 ? ' active' : ''}\" #{(cat == 'all' && @all_setting_option == 0) ? "data-count_limit=\"#{max_all_count}\"" : ''} data-read_more_text=\"#{read_more_text}\" data-read_more=\"#{read_more_url}\" data-category=\"#{cats_relations[cat]}\">#{cats_translations[cat]}</li>"
          }.join("")) +
        "</ul>"
      )
      filter_attr = (use_tag ? 'data-tags' : 'data-category')
      extra_html = '
      <script style="display:none">
        if(typeof(wpexAnimsition) == "undefined"){
          var wpexAnimsition = {
            "loading":"1",
            "inDuration":"400",
            "outDuration":"400",
            "inClass":"fade-in",
            "outClass":"fade-out",
            "need_fix_containers":".widget-announcement-4,.widget-announcement-15",
            "linkElement": "[data-list=\"announcements\"] > *",
            "children_text_block": ".w-annc__content-wrap",
            "container_block": "[data-subpart-id=\"'+subpart.id.to_s+'\"] [data-list=\"announcements\"]:not(tbody)",
            "parent_block": "[data-subpart-id=\"'+subpart.id.to_s+'\"]",
            "filter_bar": ".nav_tabs_filter",
            "filter_option": "li.filter_tab",
            "filter_attr": "'+filter_attr+'",
            "filter_target_attr": "class",
            "use_attr_filter": true,
            "equal_height": false
          };
        }else{
          var filter_attr = "'+filter_attr+'";
          wpexAnimsition.parent_block =  wpexAnimsition.parent_block + ",[data-subpart-id=\"'+subpart.id.to_s+'\"]";
          wpexAnimsition.container_block =  wpexAnimsition.container_block + ",[data-subpart-id=\"'+subpart.id.to_s+'\"] [data-list=\"announcements\"]:not(tbody)";
          if( wpexAnimsition.filter_attr.indexOf(filter_attr) == -1 ){
            wpexAnimsition.filter_attr += ("," + filter_attr);
          }
        }
        var wpexLocalize = {
          "lightboxType": "iLightbox", 
          "iLightbox": { "auto": false, "skin": "minimal", "path": "horizontal", 
                "infinite": false, "maxScale": 1, "minScale": 0, "width": 1400, "height": "",
                "slideshow": { "pauseTime": 3000, "startPaused": true }, 
                "effects": { "reposition": true, "repositionSpeed": 200, "switchSpeed": 300, 
                  "loadedFadeSpeed": 50, "fadeSpeed": 500 
                }, 
                "show": { "title": true, "speed": 200 }, 
                "hide": { "speed": 200 }, 
                "overlay": { "blur": true, "opacity": "0.9" },
                "slideShow": "Slideshow", "next": "Next", "previous": "Previous" , 
                "thumbnails": { "maxWidth": 120, "maxHeight": 80 } 
            } 
          };
        $(document).ready(function(){
          var first_filter_tab = $("[data-subpart-id=\"'+subpart.id.to_s+'\"] .filter_tab").eq(0);
          var read_more_url = first_filter_tab.data("read_more");
            if(read_more_url.length != 0){
              $("[data-subpart-id=\"'+subpart.id.to_s+'\"] .w-annc__more").attr("href",read_more_url);
              $("[data-subpart-id=\"'+subpart.id.to_s+'\"] .w-annc__more").text(first_filter_tab.data("read_more_text"));
            }
          $("[data-subpart-id=\"'+subpart.id.to_s+'\"] .filter_tab").click(function(){
            var read_more_url = $(this).data("read_more");
            if(read_more_url.length != 0){
              $("[data-subpart-id=\"'+subpart.id.to_s+'\"] .w-annc__more").attr("href",read_more_url);
              $("[data-subpart-id=\"'+subpart.id.to_s+'\"] .w-annc__more").text($(this).data("read_more_text"));
            }
          })
        })
      </script>
      <script src="/assets/bulletin/wpex.min.js"></script>
      <style>
      [data-list="announcements"] {
        position: relative;
      }
      </style>
      '
    else
      read_more_text = I18n.t("announcement.more")
      if cats.count == 1 && cats[0] != "all"
        begin
          read_more_text = I18n.t("announcement.more_") + ((all_tags.count == 1 && all_tags[0] != 'all') ? tags_translations[tags[0]] : cats_translations[cats[0]])
        rescue 
          nil
        end
      end
      extra_html = "
        <script style=\"display:none\">
          $(document).ready(function(){
            $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] .w-annc__more\").text(\"#{read_more_text}\");
          })
        </script>
      "
    end
    if (@read_more_option != 0 rescue false)
      extra_html += "
        <script style=\"display:none\">
          $(document).ready(function(){
            var read_more_position = #{@read_more_option};
            var read_more_block = $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] .w-annc__more\");
            if(read_more_position == 5){
              read_more_block.css('display', 'none');
            }else{
              if(read_more_position == 1 || read_more_position == 2){
                read_more_block.addClass(\"pull-left\");
              }else{
                read_more_block.addClass(\"pull-right\");
              }
              if(read_more_position == 1 || read_more_position == 3){
                var first_element = $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] > *:eq(0)\");
                var div_clearfix = $('<div class=\"clearfix\"></div>')
                if(first_element.height() == 0){
                  read_more_block.appendTo(div_clearfix);
                }else{
                  div_clearfix = read_more_block;
                }
                first_element.before(div_clearfix);
                var annc_title = $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] .w-annc__widget-title\").eq(0);
                if(annc_title.length != 0){
                  read_more_block.appendTo(\"[data-subpart-id=\\\"#{subpart.id}\\\"] .w-annc__widget-title:eq(0)\");
                }
              }else{
                var div_clearfix = $('<div class=\"clearfix\"></div>');
                read_more_block.appendTo(div_clearfix);
                $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] > *:eq(-1)\").after(div_clearfix);
              }
            }
          })
        </script>
      "
    end
    extra_after_html = ""
    if @all_setting_option == 0 && @tab_option == 1
     extra_after_html = "
      <script style=\"display:none\">
        $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] [data-list] [data-category]\").css(\"display\",\"none\");
        $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] [data-list] [data-category]:lt(#{max_all_count})\").css(\"display\",\"\");
      </script>
      "
    end
    if @tab_option == 0
      read_more_url = "#{page_url}" rescue ""
      read_more_url = read_more_url + "?" + {"category"=>all_cats,"tags"=>all_tags}.to_param if read_more_url != ""
      extra_after_html += "
      <script style=\"display:none\">
        $(\"[data-subpart-id=\\\"#{subpart.id}\\\"] .w-annc__more\").attr(\"href\",\"#{read_more_url}\");
      </script>
      "
    end
    {
      "announcements" => anns,
      "extras" => {
        "more_url"=>read_more_url,
        "main_picture" => mp,
        "main_picture_description" => mpd,
        "title-head" => t('announcement.table.title'),
        "date-head" => t('announcement.table.date'),
        "author-head" => t('announcement.table.author'),
        "annc-dept-head" => t("announcement.annc_dept"),
        "status-head" => t('announcement.table.status'),
        "subtitle-head" => t('announcement.table.sub_title'),
        "category-head" => t('announcement.table.category'),
        "link-head" => t('announcement.table.link'),
        "file-head" => t('announcement.table.file'),
        "read_more" => read_more_url,
        "read_more_text" => "read more",
        "extra_brefore_html" => extra_html,
        "extra_after_html" => extra_after_html
      }
    }
  end
  def get_tabs_option
    subpart = OrbitHelper.get_current_widget
    tab_options = ["not_enable_tabs","enable_tabs_with_categories_include_all","enable_tabs_with_categories"]
    read_more_options = ['default','upper_left','lower_left','upper_right','lower_right', 'display_none']
    all_setting_options = ['the_same_as_data_count','display_all_in_other_tabs']
    @tab_option = 0
    @read_more_option = 0
    @all_setting_option = 0
    @image_version = 'thumb'
    if subpart.methods.include? 'select_options'.to_sym
      ModuleApp.all.select{|tmp| tmp.key.to_s=='announcement'}.each do |modile_app|
        @show_options = modile_app.show_options rescue nil
      end
      I18n.with_locale(:en) do
        subpart.select_options.each do |select_option|
          if !(@show_options.nil?)
            value = YAML.load(select_option.value)
            tmp = value[:en]
            case select_option.field_name
            when @show_options.keys[0].to_s
              if tmp == t('announcement.small_size')
                @image_version = 'thumb'
              elsif tmp == t('announcement.medium_size')
                @image_version = 'mobile'
              elsif tmp == t('announcement.orignal_size')
                @image_version = 'orignal'
              end
            when @show_options.keys[1].to_s
              tab_options.each_with_index do |option,i|
                if tmp == t("announcement.#{option}")
                  @tab_option = i
                  break
                end
              end
            when @show_options.keys[2].to_s
              read_more_options.each_with_index do |option,i|
                if tmp == t("announcement.#{option}")
                  @read_more_option = i
                  break
                end
              end
            when @show_options.keys[3].to_s
              all_setting_options.each_with_index do |option,i|
                if tmp == t("announcement.#{option}")
                  @all_setting_option = i
                  break
                end
              end
            end
          end
        end
      end
    end
  end
  def get_anncs_for_pack_data(cats,tags,set_tags=nil,is_random = false)
    if @annc_depts.nil?
      @annc_depts = []
      @tmp_enable_annc_dept = (enable_annc_dept rescue false)
      if @tmp_enable_annc_dept
        @annc_depts = annc_depts_translations[locale] rescue []
      end
    end
    if tags.blank?
      tags = ["all"]
    end
    subpart = OrbitHelper.get_current_widget
    widget_data_count = OrbitHelper.widget_data_count
    anns_cache = AnnsCache.where(parent_id: subpart.id.to_s + cats.to_s + tags.to_s + widget_data_count.to_s,locale: I18n.locale.to_s)
    devide_flag = (!(defined? SiteFeed).nil?) && (SiteFeed.count != 0)
    anns_cache.all_of([{:invalid_date.ne=>nil},{:invalid_date.lte => Time.now}]).destroy
    count = anns_cache.count
    if count > 1
      anns_cache.limit(count-1).destroy
    end
    if anns_cache.count == 0 || is_random
      Bulletin.remove_expired_status
      uid = OrbitHelper.params[:uid] rescue ""
      anns_for_locale = Bulletin.where(:title.nin => ["",nil], :uid.ne => uid).is_approved_and_show.filter_cats_and_tags(cats,tags)
      sorted_anns = anns_for_locale.can_display_and_sorted
      if !is_random
        sorted_anns = sorted_anns.limit(widget_data_count)
        first_deadline = sorted_anns.pluck(:deadline).compact.sort[0]
        first_postdate = anns_for_locale.open_in_future.limit(1).pluck(:postdate)[0]
        invalid_date = [first_postdate,first_deadline].compact.sort[0]
        
        if devide_flag
          now_anns = sorted_anns.to_a
          top_anns = now_anns.select{|v| v.is_top}.map{|v| data_to_human_type(v,set_tags)}
          not_top_anns = now_anns.select{|v| !v.is_top}.map{|v| data_to_human_type(v,set_tags)}
          AnnsCache.create(parent_id: subpart.id.to_s + cats.to_s + tags.to_s + widget_data_count.to_s,locale: I18n.locale.to_s,filter_result: {top: top_anns,not_top: not_top_anns},invalid_date: invalid_date)
        else
          anns = sorted_anns.map{|v| data_to_human_type(v,set_tags)}
          AnnsCache.create(parent_id: subpart.id.to_s + cats.to_s + tags.to_s + widget_data_count.to_s,locale: I18n.locale.to_s,filter_result: anns,invalid_date: invalid_date)
        end
      else
        invalid_date = Time.now + 3.second
        if devide_flag
          anns = sorted_anns.sample(widget_data_count)
          top_anns = anns.select{|v| v.is_top}.map{|v| data_to_human_type(v,set_tags)}
          not_top_anns = anns.select{|v| !v.is_top}.map{|v| data_to_human_type(v,set_tags)}
        else
          anns = sorted_anns.sample(widget_data_count).map{|v| data_to_human_type(v,set_tags)}
        end
      end
    elsif devide_flag
      c = anns_cache.first
      now_anns = c.filter_result
      invalid_date = c.invalid_date
      top_anns = now_anns[:top]
      not_top_anns = now_anns[:not_top]
    else
      c = anns_cache.first
      invalid_date = c.invalid_date
      anns = c.filter_result
    end
    if @page_invalid_time.nil?
      @page_invalid_time = invalid_date
    elsif !invalid_date.nil? && @page_invalid_time>invalid_date
      @page_invalid_time = invalid_date
    end
    if devide_flag
      feeds_anns = get_feed_announcements("widget",nil,cats,widget_data_count - top_anns.count)
      top_anns = top_anns + feeds_anns.select{|v| v['is_top'] == true}
      if @manually_sort
        top_anns = top_anns.sort_by { |a| tmp=a["postdate"].blank?;[-a['sort_number'].to_i,tmp ? 0 : 1, tmp ? nil : a["postdate"].to_time] }.reverse
      else
        top_anns = top_anns.sort_by { |a| tmp=a["postdate"].blank?;[tmp ? 0 : 1, tmp ? nil : a["postdate"].to_time] }.reverse
      end
      rest_count = widget_data_count - top_anns.count
      if rest_count <= 0
        anns = top_anns.take(widget_data_count)
      else
        rest_all_anns = feeds_anns.select{|v| v['is_top'] != true} + not_top_anns.take(rest_count)
        rest_anns = rest_all_anns.sort_by { |a| tmp=a["postdate"].blank?;[tmp ? 0 : 1, tmp ? nil : a["postdate"].to_time] }.reverse.take(rest_count)
        anns = top_anns + rest_anns
      end
    end
    anns.each{|a| a["postdate"] = a["postdate"].in_time_zone(Time.zone.utc_offset / 3600).strftime('%Y-%m-%d %H:%M') rescue nil }
    anns
  end

  def get_file
    @url = request.path
    begin
      if @url.match(/\/\.\./)
        render :file => "#{Rails.root}/app/views/errors/404.html", :layout => false, :status => :not_found, :content_type => 'text/html'
        return
      end
      file = BulletinFile.find(params[:id])
      if File.basename(file.file.path) != URI.decode(params[:f_name])
        render :file => "#{Rails.root}/app/views/errors/403.html", :layout => false, :status => :not_found, :content_type => 'text/html'
        return
      end
      @url = file.file.url
      if file.can_access?(OrbitHelper.current_user)
        @path = file.file.path rescue ""
        @filename = @path.split("/").last
        @ext = @path.split("/").last.to_s.split(".").last
        if @ext == "png" || @ext == "jpg" || @ext == "bmp" || @ext == "pdf"
          render "archives/download_file.html",:layout=>false
        else
          if (current_site.accessibility_mode rescue false)
            render "archives/redirect_to_file.html",:layout=>false
            return
          else
            user_agent = request.user_agent.downcase
            @escaped_file_name = user_agent.match(/(msie|trident)/) ? CGI::escape(@filename) : @filename
            send_file(@path, :type=>"application/octet-stream", :filename => @escaped_file_name, :x_sendfile=> true)
            return
          end
        end
      else
        render :file => "#{Rails.root}/app/views/errors/403.html", :layout => false, :status => :not_found, :content_type => 'text/html'
        return
      end
    rescue => e
      puts [e, e.backtrace]
      render :file => "#{Rails.root}/app/views/errors/404.html", :layout => false, :status => :not_found, :content_type => 'text/html'
      return
    end
  end

  def show_local_announcement(uid, is_preview)
    locale = OrbitHelper.get_site_locale.to_s
    if is_preview
      announcement = Bulletin.where(:uid => uid).first
    else
      announcement = Bulletin.can_display_and_sorted.where(:uid => uid).first
    end
    announcement = Bulletin.where(:uid => uid).first if announcement.nil?
    return nil if announcement.nil?
    @bulletin = announcement

    url_to_edit = OrbitHelper.user_can_edit?(announcement) ? "/admin/announcements/#{announcement.id.to_s}/edit" : ""

    access_level = OrbitHelper.user_access_level?

    if !announcement.approved && (access_level != "manager" && access_level != "admin")
      if AnnouncementSetting.is_pro?
        if !(access_level == "sub_manager" && AnnouncementSetting.first.approvers.include?(OrbitHelper.current_user.id.to_s))
          return {}
        end
      elsif access_level != "sub_manager"
        return {}
      end
    end

    return {} if (announcement.category.disable rescue false)

    if !announcement.deadline.nil? && announcement.deadline < Time.now
      return {
      "tags" => [],
      "bulletin_files" => [],
      "bulletin_links" => [],
      "data" => {
        "title" => announcement.title,
        "subtitle_ann" => '',
        "update_user" => '',
        "updated_at" => '',
        "image" => '',
        "img_src" => '',
        "img_description" => '',
        "hide_class" => ' hide',
        "alt_title" => '',
        "carousel_html" => '',
        "sub_anncs_text" => '',
        "body" => "<b class='announcement_expired'>#{I18n.t('announcement.expired')}</b><br><a class='announcement_go_back_list' href='./' title='#{I18n.t('announcement.go_back')}'>#{I18n.t('announcement.go_back')}</a>".html_safe
      },
      "comments" => [],
      "show_comment_flag" => '',
      "impressionist" => nil,
      "url_to_edit"=> '',
      "redirect_to" => (announcement.is_external_link && !announcement.external_link.blank? ? announcement.external_link : nil)
    }
    end

    tags = announcement.tags.map{|tag|  {
      "tag" => tag.name ,
      "url" => OrbitHelper.page_for_tag(tag)
    } } rescue []
    files = announcement.bulletin_files.to_fronted(locale)
    links = announcement.bulletin_links.map{|link|  { "link_url" => link.url, "link_title" => (link.title.blank? ? link.url : link.title) } } rescue []
    update_user = ""
    if enable_annc_dept
      update_user = annc_depts_translations[locale][announcement.annc_dept] rescue ""
    else
      update_user = announcement.update_user.member_profile.name rescue ""
    end
    desc = announcement.image_description
    desc = (desc.nil? || desc == "" ? "announcement image" : desc)

    request = OrbitHelper.request
    meta_desc = announcement.subtitle.nil? || announcement.subtitle == ""  ? announcement.text.to_s[0..200] : announcement.subtitle
    OrbitHelper.render_meta_tags([{"property" => "og:title", "content" => announcement.title},{"property" => "og:site_name", "content" => Site.first.title},{"property" => "og:url", "content" => request.original_url.split("?").first},{"property" => "og:description", "content" => meta_desc},{"property" => "og:image", "content" => "#{request.base_url}#{announcement.image.url}"},{"property" => "og:type", "content" => "Article"}])

    subtitle_ann = nil
    img_src = nil
    img_description = nil
    subtitle_ann = announcement.subtitle if announcement.display_subtitle?
    img_src = (announcement.image.url || DefaultImgSrc) if announcement.display_img?
    img_description = announcement.image_description if (announcement.image_description.present?) && (announcement.display_img?)
    show_comment_flag = announcement.open_comment_for_user(OrbitHelper.current_user)
    bulletin_carousel_images = announcement.bulletin_carousel_images.map{|image| {"src"=>image.file.url,"description"=>image.description.to_s,"description_text"=>image.description_text }}
    resume_btn_title = (I18n.locale.to_s =="zh_tw") ? "繼續播放" : "resume"
    pause_btn_title = (I18n.locale.to_s =="zh_tw") ? "暫停播放" : "pause"
    prev_btn_title = (I18n.locale.to_s =="zh_tw") ? "上一張" : "prev"
    next_btn_title = (I18n.locale.to_s =="zh_tw") ? "下一張" : "next"
    sub_anncs_text = ""
    sub_annc_list = announcement.sub_annc_list
    if announcement.enable_sub_annc && sub_annc_list.count != 0
      params = OrbitHelper.params
      page = OrbitHelper.page rescue Page.where(:url=>params[:url]).first
      page_url = page.get_url rescue page.url
      sub_anncs = announcement.get_sub_annc_list
      display_sub_annc_date = announcement.display_sub_annc_date
      sub_anncs_text = "<style type=\"text/css\">.dataTables_paginate {float: right;margin: 4px 0 0;}.dataTables_wrapper .dataTables_paginate a.paginate_button{display: inline;}</style>"
      sub_anncs_text += "<div class=\"i-annc\"><table class=\"sub_anncs_table i-annc__table  table  table-striped\">
        <thead><tr>
        <th class=\"i-annc__th  i-annc__th--title\">#{announcement.get_sub_annc_title_trans}</th>
        #{display_sub_annc_date ? "<th class=\"i-annc__th  i-annc__th--date\">#{I18n.t("announcement.table.date")}</th>" : ''}
        </tr></thead>
        <tbody>"
      sub_anncs.each do |sub_annc|
        sub_anncs_text += "<tr><td><a href=\"#{page_url}/#{sub_annc.to_param}\" title=\"#{sub_annc.title}\" target=\"_blank\">#{sub_annc.title}</a></td>#{(display_sub_annc_date ? ('<td class="i-annc__postdate">'+sub_annc.display_postdate+'</td>') : '')}</tr>"
      end
      sub_anncs_text += "</tbody></table></div>"
      sub_anncs_text += '<script style="display:none">
      var DataTables_language = {};
      DataTables_language["zh_tw"] = {"info":"本頁為第 _START_ 項至第 _END_ 項，共有 _TOTAL_ 項","infoEmpty":"本頁為第 0 至第 0 項，共有 0 項","infoFiltered":"(來自總共 _MAX_ 項中的符合項目)","infoPostFix":"","lengthMenu":"每頁顯示 _MENU_ 個項目","processing":"處理中...","search":"快速搜尋：","zeroRecords":"沒有找到符合的項目","paginate": {"first":"第一頁","previous":"上一頁","next":"下一頁","last":"最後一頁"},"decimal":"","thousands":","};
      $(".sub_anncs_table").dataTable({"language":DataTables_language["'+I18n.locale.to_s+'"],"order":[],"orderClasses":false,"stripeClasses":["even","odd"],"pagingType":"simple"});
      </script>'
    end
    carousel_data = {
        "bulletin_carousel_images" => bulletin_carousel_images,
        "resume_btn_title" => resume_btn_title,
        "pause_btn_title" => pause_btn_title,
        "prev_btn_title" => prev_btn_title,
        "next_btn_title" => next_btn_title,
        "carousel_display_style" => (bulletin_carousel_images.count == 0 ? 'display: none' : "width: #{announcement.carousel_image_width};margin: auto;"),
        "carousel_count" => bulletin_carousel_images.count}
    carousel_html = ""
    if carousel_data["carousel_count"] != 0
      carousel_image_type = announcement.carousel_image_type
      ac = ActionController::Base.new()
      carousel_html = ac.render_to_string(:partial=>'announcements/bulletin_carousels',:locals=>{:data=>carousel_data,:carousel_image_type=>carousel_image_type})
    end
    {
      "tags" => tags,
      "bulletin_files" => files,
      "bulletin_links" => links,
      "data" => {
        "title" => announcement.title,
        "subtitle_ann" => subtitle_ann,
        "update_user" => update_user,
        "updated_at" => (announcement.postdate.in_time_zone(Time.zone.utc_offset / 3600).strftime('%Y-%m-%d %H:%M') rescue ""),
        "body" =>announcement.text,
        "image" => announcement.image.url,
        "img_src" => img_src,
        "img_description" => img_description,
        "hide_class" => announcement.display_img? ? announcement.image_display_class : ' hide',
        "alt_title" => desc,
        "carousel_html" => carousel_html,
        "sub_anncs_text" => sub_anncs_text
      },
      "comments" => announcement.comments,
      "show_comment_flag" => show_comment_flag,
      "impressionist" => (announcement.is_preview ? nil : announcement),
      "url_to_edit"=>url_to_edit,
      "redirect_to" => (announcement.is_external_link && !announcement.external_link.blank? ? announcement.external_link : nil)
    }
  end

  def show_feed_announcement(uid)
    announcement = OrbitHelper.get_from_feed(uid)
    locale = OrbitHelper.get_site_locale.to_s
    url_to_edit = "#"
    return nil if announcement.blank?
    tags = []

    announcement["tags"].each{|tag|
      t = Tag.where(:name => tag["name_translations"][locale]).first rescue nil
      if t.nil?
        I18n.locale = (locale == "en" ? :zh_tw : :en)
        t = Tag.where(:name => tag["name_translations"][locale]).first rescue nil
        I18n.locale = locale.to_sym
      end
      tags << {
        "tag" => tag["name_translations"][locale],
        "url" => (t.nil? ?  "#" : OrbitHelper.page_for_tag(t))
      }
    }

    files = announcement["bulletin_files"].map{|file|  { "file_url" =>  file["url"], "file_title" => (file["title_translations"][locale] == "" ? URI.unescape(File.basename(file["url"])) : file["title_translations"][locale] rescue '') } } rescue []

    files.each do |file|
      if file["file_url"] =="" || file["file_url"] == nil
        files.delete(file)
      end
    end
    links = announcement["bulletin_links"].map{|link|  { "link_url" => link["url"], "link_title" => (link["title_translations"][locale] == "" ? link["url"] : link["title_translations"][locale]) } } rescue []

    update_user = announcement["author"]
    desc = announcement["image_description_translations"][locale] rescue ""
    desc = (desc.nil? || desc == "" ? "announcement image" : desc)
    img_description = nil
    img_description = announcement["image_description_translations"][I18n.locale] if announcement['display_img']
    img_src = nil
    img_src = (announcement['image']['original'] || DefaultImgSrc) if announcement['display_img']
    subtitle_ann = announcement['subtitle_ann']
    request = OrbitHelper.request
    if announcement["subtitle_translations"].present?
      meta_desc = announcement["subtitle_translations"][locale] != "" ? announcement["subtitle_translations"][locale] : announcement["text_translations"][locale][0..200] rescue ""
    else
      meta_desc = ""
    end

    OrbitHelper.render_meta_tags([{"property" => "og:title", "content" => announcement["title_translations"][locale]},{"property" => "og:site_name", "content" => Site.first.title},{"property" => "og:url", "content" => request.original_url.split("?").first},{"property" => "og:description", "content" => meta_desc},{"property" => "og:image", "content" => announcement["image"]["original"]},{"property" => "og:type", "content" => "Article"}])

    datetime = DateTime.parse(announcement["postdate"])

    bulletin_carousel_images = Array(announcement["bulletin_carousel_images"])
    resume_btn_title = (I18n.locale.to_s =="zh_tw") ? "繼續播放" : "resume"
    pause_btn_title = (I18n.locale.to_s =="zh_tw") ? "暫停播放" : "pause"
    prev_btn_title = (I18n.locale.to_s =="zh_tw") ? "上一張" : "prev"
    next_btn_title = (I18n.locale.to_s =="zh_tw") ? "下一張" : "next"
    carousel_data = {
        "bulletin_carousel_images" => bulletin_carousel_images,
        "resume_btn_title" => resume_btn_title,
        "pause_btn_title" => pause_btn_title,
        "prev_btn_title" => prev_btn_title,
        "next_btn_title" => next_btn_title,
        "carousel_display_style" => (bulletin_carousel_images.count == 0 ? 'display: none' : "width: #{AnnouncementSetting.last.carousel_image_width};margin: auto;"),
        "carousel_count" => bulletin_carousel_images.count}
    carousel_html = ""
    if carousel_data["carousel_count"] != 0
      carousel_image_type = announcement["carousel_image_type"].to_i
      carousel_html = render(:partial=>'bulletin_carousels',:locals=>{:data=>carousel_data,:carousel_image_type=>carousel_image_type})
    end
    {
      "tags" => tags,
      "bulletin_files" => files,
      "bulletin_links" => links,
      "data" => {
        "title" => announcement["title_translations"][locale],
        "subtitle_ann" => subtitle_ann,
        "update_user" => update_user,
        "updated_at" => (datetime.in_time_zone(Time.zone.utc_offset / 3600).strftime('%Y-%m-%d %H:%M') rescue ""),
        "body" => announcement["text_translations"][locale],
        "image" => announcement["image"]["original"],
        "img_src" => img_src,
        "img_description" => img_description,
        "hide_class" => announcement["display_img"]  ? '' : ' hide',
        "alt_title" => desc,
        "carousel_html" => carousel_html,
        "sub_anncs_text" => ""
      },
      "comments" => [],
      "show_comment_flag" => false,
      "impressionist" => nil,
      "url_to_edit" => url_to_edit
    }
  end

  def show
    params = OrbitHelper.params
    uid = params[:uid]
    if OrbitHelper.is_object_from_feed?(uid)
      show_feed_announcement(uid)
    else
      show_local_announcement(uid, (params["preview"] == "true" ? true : false))
    end
  end
  def show_widget
    @type = "show_widget"
    @show_page = params[:show_page]
    if params[:tags].nil?
      @tags = ['all']
    else
      @tags = params[:tags]
    end
    if params[:categories].nil?
      @categories = ['all']
    else
      @categories = params[:categories]
    end
    begin
      params[:url] = Page.first.find_page(:module=>"announcement",:enabled_for=>I18n.locale.to_s).first.url rescue Page.where(:module=>"announcement",:enabled_for=>I18n.locale.to_s).first.url
    rescue
    end
    OrbitHelper.set_site_locale(I18n.locale)
    OrbitHelper.set_current_widget_module("announcement")
    OrbitHelper.set_params(params,current_user)
    Bulletin.remove_expired_status
    OrbitHelper.set_page_number(params[:page_no].to_i)
    OrbitHelper.set_page_data_count((params[:data_count].blank? ? 10 : params[:data_count].to_i))
    sorted,total_pages = get_sorted_annc
    annc_depts = []
    tmp_enable_annc_dept = (enable_annc_dept rescue false)
    if tmp_enable_annc_dept
      annc_depts = annc_depts_translations[locale] rescue []
    end
    anns = sorted.collect do |a|
      if a["source-site"].blank?
        statuses = a.statuses_with_classname.collect do |status|
          {
            "status" => status["name"],
            "status-class" => "status-#{status['classname']}"
          }
        end
        locale = I18n.locale.to_s
        files = a.bulletin_files.to_fronted(locale)
        links = a.bulletin_links.map{|link|  { "link_url" => link.url, "link_title" => (link.title.blank? ? link.url : link.title) } } rescue []
        author = tmp_enable_annc_dept ? annc_depts[a.annc_dept] : User.find(a.update_user_id).member_profile.name rescue ""
        desc = a.image_description
        desc = (desc.blank? ? "announcement image" : desc)
        link_to_show = (a.is_external_link ? a.external_link :  OrbitHelper.url_to_show(a.to_param)) rescue ""
        target = a.is_external_link ? "_blank" : "_self"
        doc = Nokogiri::HTML(a.title)
        title = doc.text.empty? ? 'no content' : doc.text
        {
          "department" => author,
          "bulletin_links" => links,
          "bulletin_files" => files,
          "title" => a.title,
          "source-site" => "",
          "source-site-title" => "",
          "source-site-link" => "",
          "subtitle" => a.subtitle,
          "statuses" => statuses,
          "category" => (a.category.title rescue ""),
          "postdate" => a.postdate,
          "author" => author,
          "is_top" => (a.is_top? ? 1 : 0),
          "link_to_show" => link_to_show+"\" #{(link_to_show[0] == '/' rescue true) ? '' : 'target="_blank"'} title=\"#{title}",
          "target" => target,
          "img_src" => a.image.thumb.url || DefaultImgSrc,
          "img_description" => desc,
          "more" => t("announcement.more"),
          "view_count" => a.view_count
        }
      else
        a
      end
    end
    #If no data , hide title&table
    if sorted.count == 0
      display = "hide"
    end
    # anns = anns.concat(feeds_anns)
    # total_pages = announcements.total_pages


    @data = {
      "announcements" => anns,
      "extras" => {
        "widget-title" =>t('announcement.announcement'),
        "title-head" => t('announcement.table.title'),
        "date-head" => t('announcement.table.date'),
        "status-head" => t('announcement.table.status'),
        "author-head" => t('announcement.table.author'),
        "subtitle-head" => t('announcement.table.sub_title'),
        "category-head" => t('announcement.table.category'),
        "link-head" => t('announcement.table.link'),
        "file-head" => t('announcement.table.file'),
        "view-count-head" => t('announcement.table.view_count'),
        "display" => display,
        "department-head" => t('announcement.table.department')
      },
      "total_pages" => total_pages
    }
    @layout_type = params[:layout_type]
    if @layout_type.blank?
      @layout_type = 'annc_index1'
    else
      @layout_type = @layout_type.to_s
      if File.dirname(@layout_type) != '.'
        render_400 and return
      end
    end
    render :layout => false
  end

  def agenda
    I18n.with_locale(params[:locale]||I18n.locale) do
      if !params[:subpart_id].nil?
        subpartid = params[:subpart_id]
        subpart = SubPart.find(subpartid)
        all_cats = subpart.categories
        all_cats = ['all'] if all_cats.length==0
        all_tags = subpart.tags
        all_tags = ['all'] if all_tags.length==0
        page = Page.where(:page_id=> subpart.read_more_page_id).first rescue nil
        page = Page.where(:module => "announcement").first rescue nil if page.nil?
        read_more_url_root = "/#{I18n.locale.to_s + page.url}" rescue ""
        read_more_url = read_more_url_root + "?" + {"category"=>all_cats,"tags"=> all_tags}.to_param if read_more_url != ""
      else
        page = Page.where(:module => "announcement").first
        read_more_url_root = "/#{I18n.locale.to_s + page.url}" rescue ""
      end
      if params[:unix_start].present? && params[:unix_end].present?
        agenda_start = Time.at(params[:unix_start].to_i).utc.to_s
        agenda_end = Time.at(params[:unix_end].to_i).utc.to_s
        events = Bulletin.agenda_events(agenda_start,agenda_end,read_more_url_root)
      end
      render json: {"events" => events,"calendar_title"=>get_calendar_title(Time.at(params[:month_start].to_i).utc)}.to_json({"frontend" => true})
    end
  end

  def get_calendar_title(now_date=nil)
    now_date = Time.now.utc if now_date.nil?
    month_name = I18n.locale.to_s=='zh_tw' ? now_date.month : I18n.t("announcement.month_name.#{now_date.month}")
    I18n.t("announcement.calendar_title",year: now_date.year,month: month_name)
  end
end
